import type { User } from "@/js/contexts/shared/models/User";

export type Link = {
  readonly id: number;
  url: string;
  code: string;
  type: string;
  title: string | null;
  description: string | null;
  tags: string[] | null;
  readonly user_id: string | null;
  domain_id: string | null;
  expires_at: string | null;
  readonly visits_count?: number;
  readonly qr: string;
  readonly favicon: string;
  readonly has_password: boolean;
  readonly short_url: string;
  readonly created_at: string;
  readonly updated_at: string;
};

export type LinkCreate = Omit<
  Link,
  "id" | "code" | "type" | "title" | "description" | "tags" | "qr" | "favicon" | "short_url" | "has_password" | "user_id" | "domain_id" | "expires_at" | "created_at" | "updated_at"
> & {
  code?: string;
  type?: string;
  password?: string;
  title?: string;
  description?: string;
  tags?: string;
  domain_id?: string;
  expires_at?: string;
};
export type LinkUpdate = Omit<Link, "id" | "qr" | "favicon" | "short_url" | "has_password" | "user_id" | "created_at" | "updated_at"> & { password?: string };
export type LinkWithUser = Link & { readonly user: User | null };
